/*
 * (C) Copyright The University of Manchester 2004
 */
package org.binarytranslator.PPC_Emulator;

/**
 * This class is largely used to work out the HIR to create in PPC_InstructionTranslator
 */
public class PPC_Interpret {


  PPC_ProcessSpace ps;

  public boolean testNaN(double d)
  {

	 return Double.isNaN(d);

  }

  public double bitsToDb(int n)
  {

	 long m = (long)n;

	 return Double.longBitsToDouble(m);

  }

  public void sc()
  {

	 ps.doSysCall();

  }

  boolean b_or(boolean a, boolean b)
  {

	 return a | b;

  }

  public int rotateRight ( int value , int n )
  { 
	 return(value >>> n) | (value << (32- n));
  }
		
  public int rotateLeft ( int value , int n )
  {
	 return(value << n) | (value >>> (32- n));
  } 

  int rshift(int rs, int sh)
  {

	 return rs >>> sh;

  }

  int or (int rs, int rb) {
	 return rs | rb;
  }

  int getRegister (int r) {
	 switch (r) {
	 case 0: return ps.r0;
	 case 1: return ps.r1;
	 case 2: return ps.r2;
	 case 3: return ps.r3;
	 case 4: return ps.r4;
	 case 5: return ps.r5;
	 case 6: return ps.r6;
	 case 7: return ps.r7;
	 case 8: return ps.r8;
	 case 9: return ps.r9;
	 case 10: return ps.r10;
	 case 11: return ps.r11;
	 case 12: return ps.r12;
	 case 13: return ps.r13;
	 case 14: return ps.r14;
	 case 15: return ps.r15;
	 case 16: return ps.r16;
	 case 17: return ps.r17;
	 case 18: return ps.r18;
	 case 19: return ps.r19;
	 case 20: return ps.r20;
	 case 21: return ps.r21;
	 case 22: return ps.r22;
	 case 23: return ps.r23;
	 case 24: return ps.r24;
	 case 25: return ps.r25;
	 case 26: return ps.r26;
	 case 27: return ps.r27;
	 case 28: return ps.r28;
	 case 29: return ps.r29;
	 case 30: return ps.r30;
	 case 31: return ps.r31;
	 default: throw new Error("Unknown register r" + r);
	 }
  }

  void putRegister (int r, int v) {
	 switch (r) {
	 case 0: ps.r0=v;
	 case 1: ps.r1=v;
	 case 2: ps.r2=v;
	 case 3: ps.r3=v;
	 case 4: ps.r4=v;
	 case 5: ps.r5=v;
	 case 6: ps.r6=v;
	 case 7: ps.r7=v;
	 case 8: ps.r8=v;
	 case 9: ps.r9=v;
	 case 10: ps.r10=v;
	 case 11: ps.r11=v;
	 case 12: ps.r12=v;
	 case 13: ps.r13=v;
	 case 14: ps.r14=v;
	 case 15: ps.r15=v;
	 case 16: ps.r16=v;
	 case 17: ps.r17=v;
	 case 18: ps.r18=v;
	 case 19: ps.r19=v;
	 case 20: ps.r20=v;
	 case 21: ps.r21=v;
	 case 22: ps.r22=v;
	 case 23: ps.r23=v;
	 case 24: ps.r24=v;
	 case 25: ps.r25=v;
	 case 26: ps.r26=v;
	 case 27: ps.r27=v;
	 case 28: ps.r28=v;
	 case 29: ps.r29=v;
	 case 30: ps.r30=v;
	 case 31: ps.r31=v;
	 default: throw new Error("Unknown register r" + r);
	 }
  }

  void decodeInstruction(int instr) {
	 switch(instr >>> 26) {
	 case 0x1f:
		switch((instr & 0x7fe)>>> 1) {
		case 0x1bc: // OR
		  putRegister((instr & 0x1F0000) >>> 16, or( getRegister((instr & 0x3E00000) >>> 21), getRegister((instr & 0x7c00) >>> 11)));
		  break;
		default: throw new Error("Unknown secondary 0x" + Integer.toHexString((instr & 0x7fe)>>> 1) +
										 " in instr 0x" + Integer.toHexString(instr));
								
		}
		break;
	 default: throw new Error("Unknown primary 0x" + Integer.toHexString(instr >>> 26) +
									  " in instr 0x" + Integer.toHexString(instr));
	 }
  }

}
