/*
 * (C) Copyright IBM Corp. 2001
 */
// $Id: VM_AssemblerConstants.java,v 1.1.8.1 2004/07/30 11:19:22 irogers Exp $
package com.ibm.JikesRVM;
/**
 * Constants exported by the assembler
 * @author Julian Dolby
 */
public interface VM_AssemblerConstants {
  static final String [] CONDITION = {
   "O", "NO", "LLT", "LGE", "EQ", "NE", "LLE", "LGT", "S", "NS", "PE", "PO", "LT", "GE", "LE", "GT" 
  };

  static final byte   O = 0x0; // (overflow) - OF == 1
  static final byte  NO = 0x1; // (not overflow) - OF == 0
  static final byte LLT = 0x2; // logically less than (below) - CF == 1
  static final byte LGE = 0x3; // logically greater than or equal (not below) - CF == 0
  static final byte  EQ = 0x4; // equal (zero) - ZF == 1
  static final byte  NE = 0x5; // not equal (not zero) - ZF == 0
  static final byte LLE = 0x6; // logically less than or equal (not above) - CF == 1 or ZF == 1
  static final byte LGT = 0x7; // logically greater than (above) - CF == 0 and ZF == 0
  static final byte   S = 0x8; // (sign) negative?? - SF == 1
  static final byte  NS = 0x9; // (not sign) positive or zero?? - SF == 0
  static final byte  PE = 0xA; // (even parity) - PF == 1
  static final byte  PO = 0xB; // (odd parity) - PF == 0
  static final byte  U  = 0xA; // (unordered floating point #s) - PF == 1
  static final byte  NU = 0xB; // (ordered floating point #s) - PF == 0
  static final byte  LT = 0xC; // less than - SF != OF
  static final byte  GE = 0xD; // greater than or equal (not less than) - SF == OF
  static final byte  LE = 0xE; // less than or equal (not greater than) - ZF == 1 or SF != OF
  static final byte  GT = 0xF; // greater than - ZF == 0 and SF == OF

  // scale factors for SIB bytes
  static final short BYTE  = 0;
  static final short SHORT = 1;
  static final short WORD  = 2;
  static final short LONG  = 3;

}
